#include <Generic\HashMap.mqh>

#include "ValuesID.mqh"

template <typename TKey, typename TValue>
class CLASSIFICATOR
{
private:
  VALUESID<TValue> ValuesID[];
  CHashMap<TKey, int> Index;

public:
  static int Reserve;

  bool Add( const TKey Key, const TValue &Value )
  {
    int Pos;

    if (!this.Index.TryGetValue(Key, Pos))
    {
      Pos = ::ArrayResize(this.ValuesID, ::ArraySize(this.ValuesID) + 1, CLASSIFICATOR<TKey, TValue>::Reserve) - 1;

      this.Index.Add(Key, Pos);
    }

    const bool Res = (this.ValuesID[Pos] += Value);

    if (!Res)
    {
      const int Size = ::ArraySize(this.ValuesID[Pos].Values);

      ::Print(__FILE__ + " " + __FUNCSIG__ + ", Line =  " + (string)__LINE__ + ": Key = " + (string)Key + ", Value = " + (string)Value +
              ", Size = " + (string)Size + ", Values[Size - 1] = " + (string)this.ValuesID[Pos].Values[Size - 1] + ", Pos = " + (string)Pos);

      ::ArrayPrint(this.ValuesID[Pos].Values);
    }

    return(Res);
  }

  int Get( const TKey &Key, TValue &Array[] ) // const // https://www.mql5.com/ru/forum/221917/page34
  {
    int Pos;

    return(this.Index.TryGetValue(Key, Pos) ? this.ValuesID[Pos].Copy(Array) : 0);
  }

  int GetKeys( TKey &Keys[] ) // const
  {
    int Array[];

    return(this.Index.CopyTo(Keys, Array));
  }
};

template <typename TKey, typename TValue>
static int CLASSIFICATOR::Reserve = 0;